/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.enums.EnumIsocode;
import de.ship.db.enums.EnumTransCategory;
import de.ship.db.tables.records.VCoreValuelistDataquierRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreValuelistDataquier extends TableImpl<VCoreValuelistDataquierRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of
     * <code>common_dd.v_core_valuelist_dataquier</code>
     */
    public static final VCoreValuelistDataquier V_CORE_VALUELIST_DATAQUIER = new VCoreValuelistDataquier();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreValuelistDataquierRecord> getRecordType() {
        return VCoreValuelistDataquierRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_valuelist_dataquier.id</code>.
     */
    public final TableField<VCoreValuelistDataquierRecord, Integer> ID = createField(DSL.name("id"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_valuelist_dataquier.varvalues</code>.
     */
    public final TableField<VCoreValuelistDataquierRecord, String> VARVALUES = createField(DSL.name("varvalues"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_valuelist_dataquier.category</code>.
     */
    public final TableField<VCoreValuelistDataquierRecord, EnumTransCategory> CATEGORY = createField(DSL.name("category"), SQLDataType.VARCHAR.asEnumDataType(EnumTransCategory.class), this, "");

    /**
     * The column <code>common_dd.v_core_valuelist_dataquier.isocode</code>.
     */
    public final TableField<VCoreValuelistDataquierRecord, EnumIsocode> ISOCODE = createField(DSL.name("isocode"), SQLDataType.VARCHAR.asEnumDataType(EnumIsocode.class), this, "");

    private VCoreValuelistDataquier(Name alias, Table<VCoreValuelistDataquierRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreValuelistDataquier(Name alias, Table<VCoreValuelistDataquierRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_valuelist_dataquier" as  WITH x(id, value, value_order, isocode, category) AS (
                SELECT l.valuelist AS id,
                   ((v.varvalue || '='::text) || t.value) AS "?column?",
                   v.value_order,
                   t.isocode,
                   t.category
                  FROM (((common_dd.t_core_valuelist l
                    LEFT JOIN common_dd.t_core_value v ON ((v.fk_value_valuelist = l.valuelist)))
                    LEFT JOIN common_dd.t_core_valueparam vp ON ((vp.fk_valueparam_value = v.pk_core_value)))
                    LEFT JOIN common_dd.t_core_translation t ON ((t.fk_trans_key = vp.param_key)))
                 ORDER BY l.valuelist, v.value_order
               )
        SELECT id,
           string_agg(value, '|'::text ORDER BY value_order) AS varvalues,
           category,
           isocode
          FROM x
         WHERE (isocode IS NOT NULL)
         GROUP BY id, category, isocode;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_valuelist_dataquier</code> table
     * reference
     */
    public VCoreValuelistDataquier(String alias) {
        this(DSL.name(alias), V_CORE_VALUELIST_DATAQUIER);
    }

    /**
     * Create an aliased <code>common_dd.v_core_valuelist_dataquier</code> table
     * reference
     */
    public VCoreValuelistDataquier(Name alias) {
        this(alias, V_CORE_VALUELIST_DATAQUIER);
    }

    /**
     * Create a <code>common_dd.v_core_valuelist_dataquier</code> table
     * reference
     */
    public VCoreValuelistDataquier() {
        this(DSL.name("v_core_valuelist_dataquier"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreValuelistDataquier as(String alias) {
        return new VCoreValuelistDataquier(DSL.name(alias), this);
    }

    @Override
    public VCoreValuelistDataquier as(Name alias) {
        return new VCoreValuelistDataquier(alias, this);
    }

    @Override
    public VCoreValuelistDataquier as(Table<?> alias) {
        return new VCoreValuelistDataquier(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreValuelistDataquier rename(String name) {
        return new VCoreValuelistDataquier(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreValuelistDataquier rename(Name name) {
        return new VCoreValuelistDataquier(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreValuelistDataquier rename(Table<?> name) {
        return new VCoreValuelistDataquier(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistDataquier where(Condition condition) {
        return new VCoreValuelistDataquier(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistDataquier where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistDataquier where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistDataquier where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreValuelistDataquier where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreValuelistDataquier where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreValuelistDataquier where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreValuelistDataquier where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistDataquier whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistDataquier whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
